//#pragma once
#include "sender.h"
#include "SiTCP.h"
#include <iostream>
#include <fstream>
#include <string>
#include <unistd.h>
#include "stdio.h"
#include "stdlib.h"
#include"src/easiroc.h"
#include"src/SC.hh"
#include<ios>
#include<sys/stat.h>

#define IpAddr "192.168.10.16"
#define tcpport 24
#define udpport 4660
#define binary(bit) strtol(bit,NULL,2)

extern unsigned int slowdata[sizeByte_SC];
extern unsigned int ReadSCdata[sizeByte_RSC];
extern unsigned int Probedata[sizeByte_PSC];
extern unsigned int Pindata[sizeByte_PIN];

int ForceStop = 0;
int EndADC = 0;
int receive(int sock, char* data_buf, unsigned int *ReadLength);
int WriteData(int socket, unsigned int data);
int ReadData(int socket, unsigned int signal, unsigned int data);
int ContinuousADC_ver5(int socket);
int ADCOneCycle_wHeader_ver5(int socket, std::ofstream& file);
void ADCStop(int socket);



using namespace std;
int main(int argc, char *argv[]){
  SiTCP* sitcp = new SiTCP();
  sitcp -> SetIPPort(IpAddr, tcpport, udpport);
//  sitcp -> CreateTCPSock();
  sitcp -> CreateUDPSock();
  Sender* sender = new Sender();
  std::string filename;
  int sock = 0;
  const char*  IP;
  unsigned int port;
  struct sockaddr_in SiTCP_ADDR;
  sock = socket(AF_INET, SOCK_STREAM, tcpport);//IPPROTO_TCP);
  IP                         = IpAddr;//SiTCP_MASTER_IP;
  port                       = tcpport;//SiTCP_PORT;
  SiTCP_ADDR.sin_family      = AF_INET;
  SiTCP_ADDR.sin_port        = htons(port);
  SiTCP_ADDR.sin_addr.s_addr = inet_addr(IP);

  sock = 3;
  cout<<"sock:"<<sock<<endl;
//  cout<<"sitcp:"<<sitcp<<endl;


//  int menu(0);
 
//  int HVDAC(0);
//  int MADC(0);
//  int MUX(0);
//  double HV(0);
//  double rd_data(0);
//  float DACdata[63];

  //std::cout<<"reset register"<<std::endl;
  //  sender->clear_all(sitcp);
//  usleep(200);

//  float HVC_1 = 483.183;
// float HVC_2 = 780;
  // HVDAC =HVC_1 * HV + HVC_2;            convert HV to DAC bit

//  float ADC2HV = 0.00208;
  //  rd_data = ADC2HV * rd_data;          convert ADC bit to HV

 // float ADC2uA = 0.034;
  //  rd_data = ADC2uA * rd_data;          convert ADC bit to HVcurrent

  //float ADC2V = 0.0000685;
  //rd_data = ADC2V * rd_data;             convert ADC bit to inputDAC Voltage

  //float ADC2K = 4500;
  //  rd_data = ADC2K * rd_data/65535/2.4; convert ADC bit to TEMP(K)
 
sender->udp_send(sitcp,0x00000012,248); //Set ADC rate to 50Hz
sender->udp_send(sitcp,0x0000001f,0);

ContinuousADC_ver5(sock);
//ContinuousADC_ver5(sitcp);

/*while(1){

    menu = 0;
    std::cout << "" << std::endl;
    std::cout << "--------------------Select Menu--------------------" << std::endl;
    std::cout << "" << std::endl;
    std::cout << "1.HV control" << std::endl;
    std::cout << "2.HV status" << std::endl;
    std::cout << "3.Input DAC scan" << std::endl;
    std::cout << "4.Read TEMP." << std::endl;
    std::cout << "5.Exit" << std::endl;
    std::cout << "8.MUX control" << std::endl;
    std::cout << "9.Read MADC" << std::endl;
    std::cin >> menu;
    

 
    if(menu == 1){

      std::cout << "input 0.00~90.00V "<<std::endl;;
      std::cin >> HV;
      //std::cout << HV << std::endl;
      
      //HVDAC = HV;
      HVDAC = HVC_1 * HV + HVC_2;        //change HV to DAC bit
      // std::cout << HVDAC << std::endl;      
      
      sender->udp_send(sitcp,0x00000010,HVDAC/256);//Set higher 8bit to FPGA reg
      sender->udp_send(sitcp,0x00000011,HVDAC%256);//lower 8bit
      sender->udp_send(sitcp,0x0000001e,1); //Start DAC control

    }
    else if(menu == 2){
      std::cout<<std::endl << "Bias voltage";
      rd_data = sender->read_madc(sitcp,3);//Read ADC data      
	//	std::cout <<"MADC_data = "<< rd_data;
      	rd_data = ADC2HV * rd_data; //convert ADC bit to HV
	printf(" : %.2lfV\n",rd_data);

	rd_data = sender->read_madc(sitcp,4);//Read ADC data      
	//std::cout <<"MADC_data = "<< rd_data;
      	rd_data = ADC2uA * rd_data;   //convert ADC bit to HVcurrent
	printf("Bias current : %.2lfuA",rd_data);
    }
    else if(menu == 4){
      
	rd_data = sender->read_madc(sitcp,5);//Read ADC data      
//	std::cout <<"MADC_data = "<< rd_data;

//debug
	rd_data = sender->read_madc(sitcp,2);//Read ADC data      
	std::cout <<"MADC_data = "<< rd_data;

	rd_data = ADC2K * rd_data/65535/2.4; //convert ADC bit to TEMP(K)
	rd_data = rd_data - 273;     //convert K to C
	printf("TEMP1 : %.2lfC\n",rd_data);

	rd_data = sender->read_madc(sitcp,0);//Read ADC data   
	//	std::cout <<"MADC_data = "<< rd_data;
	rd_data = ADC2K * rd_data/65535/2.4; //convert ADC bit to TEMP(K)
	rd_data = rd_data - 273;     //convert K to C
	printf("TEMP2 : %.2lfC",rd_data);


    }
    else if(menu == 9){
     

      std::cout << "" << std::endl;
      std::cout << "--------------------Select ADC ch--------------------" << std::endl;
      std::cout << "" << std::endl;
      std::cout << "1.Bias_voltage" << std::endl;
      std::cout << "2.Bias_current" << std::endl;
      std::cout << "3.inputDAC_1" << std::endl;
      std::cout << "4.inputDAC_2" << std::endl;
      std::cout << "5.TEMP_1" << std::endl;
      std::cout << "6.TEMP_2" << std::endl;
      std::cin >> MADC;
      
      
      switch(MADC){
      case 1:
	std::cout << "Bias voltage read" << std::endl;

	rd_data = sender->read_madc(sitcp,3);//Read ADC data 
      	rd_data = ADC2HV * rd_data; //convert ADC bit to HV
	printf(" : %.2lfV",rd_data);

	break;

      case 2:
	std::cout << "Bias current read" << std::endl;

	rd_data = sender->read_madc(sitcp,4);//Read ADC data 
      	rd_data = ADC2uA * rd_data;   //convert ADC bit to HVcurrent
	printf(" : %.2lfuA",rd_data);

      break;

      case 3:
      case 4:
	std::cout << "Input DAC read" << std::endl;

	rd_data = sender->read_madc(sitcp,MADC-2);//Read ADC data 
	rd_data = ADC2V * rd_data; //convert ADC bit to V
	printf(" : %.2lfV",rd_data);

      break;

      case 5:
	std::cout << "TEMP read" << std::endl;

	rd_data = sender->read_madc(sitcp,5);//Read ADC data 
	rd_data = ADC2K * rd_data/65535/2.4; //convert ADC bit to TEMP(K)
	rd_data = rd_data - 273;     //convert K to C
	printf(" : %.2lfC",rd_data);


      break;

      case 6:
	std::cout << "TEMP read" << std::endl;

	rd_data = sender->read_madc(sitcp,0);//Read ADC data 
	rd_data = ADC2K * rd_data/65535/2.4; //convert ADC bit to TEMP(K)
	rd_data = rd_data - 273;     //convert K to C
	printf(" : %.2lfC",rd_data);

      break;

      default:
 	break;
      }          
    }

  
    else if(menu == 3){
     
      //std::cout << "Bias voltage" << std::endl;
      rd_data = sender->read_madc(sitcp,3);//Read ADC data       
      //std::cout <<"MADC_data = "<< rd_data;
      rd_data = ADC2HV * rd_data; //convert ADC bit to HV
      printf("Bias voltage : %.2lfV\n\n",rd_data);
      double Bias = rd_data;
      
      std::cout << "Input DAC scan" << std::endl <<std::endl;
      int i=0;
      for(i=0;i<33;i++){
	if(i%2 == 0 && i < 16){
	  MUX = 199 - i/2;      
	}
	else if(i%2 == 1 && i < 16){
	  MUX = 207 - i/2;      
	}
	else if(i%2 == 0 && i < 32 && i > 15){
	  MUX = 55 - (i -16)/2;      
	}
	else if(i%2 == 1 && i < 32 && i > 15){
	  MUX = 63 - (i -16)/2;      
	}
	else if(i == 32){
	  MUX = 0;
	}
	//std::cout << MUX;
	sender->udp_send(sitcp,0x00000013,MUX);
	usleep(2000);                          
	if(i<32){
	rd_data = sender->read_madc(sitcp,1);//Read ADC data      
	//std::cout <<"MADC_data = "<< rd_data;
	rd_data = ADC2V * rd_data; //convert ADC bit to V
	printf("ch%d = %.2lfV   ",i,rd_data);
	//printf("%.2lf\n",rd_data);
	printf("%d = %.2lfV     ",i,Bias - rd_data);

	rd_data = sender->read_madc(sitcp,2);//Read ADC data        
	//std::cout <<"MADC_data = "<< rd_data;
	rd_data = ADC2V * rd_data; //convert ADC bit to V
	//printf("ch%d = %.2lfV   ",i+32,rd_data);
	//printf("%d = %.2lfV\n",i+32,Bias - rd_data);

	}
      }
    }

    else if(menu == 8){

      std::cout << "input DAC ch ? (0~32 : 32 = no connection) "<<std::endl;;
      std::cin >> MUX;
      std::cout << MUX << std::endl; 
      if(MUX%2 == 0 && MUX < 16){
	MUX = 199 - MUX/2;      
      }
      if(MUX%2 == 1 && MUX < 16){
	MUX = 207 - MUX/2;      
      }
      if(MUX%2 == 0 && MUX < 32 && MUX > 15){
	MUX = 55 - (MUX -16)/2;      
      }
      if(MUX%2 == 1 && MUX < 32 && MUX > 15){
	MUX = 63 - (MUX -16)/2;      
      }
      else if(MUX == 32){
	MUX = 0;
      }
      
      std::cout << MUX << std::endl;
      sender->udp_send(sitcp,0x00000013,MUX);
     
           
    }

    else if(menu == 7){
      
      std::ofstream out("data.dat");
      out.close();
      
      while(1){
	
	std::ofstream outf(("data.dat"),std::ios::app);
	if(!outf){
	  std::cout<<"Error Open File"<<std::endl;
	}
	
	outf<<11111111<<std::endl;
	
	
	rd_data = sender->read_madc(sitcp,3);//Read ADC data      
	//	std::cout <<"MADC_data = "<< rd_data;
	rd_data = ADC2HV * rd_data; //convert ADC bit to HV
	printf("Bias voltage : %.2lfV\n",rd_data);
	double Bias = rd_data;    
	
	outf<<rd_data<<std::endl;
        
	rd_data = sender->read_madc(sitcp,4);//Read ADC data      
	//std::cout <<"MADC_data = "<< rd_data;
	rd_data = ADC2uA * rd_data;   //convert ADC bit to HVcurrent
	printf("Bias current : %.2lfuA\n",rd_data);
	
	outf<<rd_data<<std::endl;
	
	//std::cout << "Input DAC scan" << std::endl <<std::endl;
	int i=0;
	for(i=0;i<33;i++){
	  if(i%2 == 0 && i < 16){
	    MUX = 199 - i/2;      
	  }
	  else if(i%2 == 1 && i < 16){
	    MUX = 207 - i/2;      
	  }
	  else if(i%2 == 0 && i < 32 && i > 15){
	    MUX = 55 - (i -16)/2;      
	  }
	  else if(i%2 == 1 && i < 32 && i > 15){
	    MUX = 63 - (i -16)/2;      
	  }
	  else if(i == 32){
	    MUX = 0;
	  }
	  //std::cout << MUX;
	  sender->udp_send(sitcp,0x00000013,MUX);
	  usleep(2000);                          
	  if(i<32){
	    rd_data = sender->read_madc(sitcp,1);//Read ADC data      
	    //std::cout <<"MADC_data = "<< rd_data;
	    rd_data = ADC2V * rd_data; //convert ADC bit to V
	    printf("ch%d = %.2lfV   ",i,rd_data);
	    printf("%d = %.2lfV     ",i,Bias - rd_data);
	    DACdata[i] = rd_data;
	    
	    rd_data = sender->read_madc(sitcp,2);//Read ADC data        
	    //std::cout <<"MADC_data = "<< rd_data;
	    rd_data = ADC2V * rd_data; //convert ADC bit to V
	    printf("ch%d = %.2lfV   ",i+32,rd_data);
	    printf("%d = %.2lfV\n",i+32,Bias - rd_data);
	    DACdata[i+32] = rd_data;
	  }
	}
	int k = 0;
	while(k != 64){
	  outf<<DACdata[k]<<std::endl;
	  k++;
	}
	outf.close();
	sleep(300);      
      }
    }     
    else if(menu == 5){
      break;

    }

      
    else{
      std::cout<< "" <<std::endl;
   
    }
 
}*/
    

/* ------------------Finalize------------------ */   
  sender->udp_send(sitcp,0x00000010,0);//Set higher 8bit to FPGA reg
  sender->udp_send(sitcp,0x00000011,0);//lower 8bit
  sender->udp_send(sitcp,0x0000001e,1); //Start DAC control
  
  sitcp->CloseUDPSock();
  
  delete sitcp;
  delete sender;
  
  return 0;
}


int ContinuousADC_ver5(int socket){
	char name[500];//,cmd[100];
	string dirname, a,filename;
	int RunNo;

	ifstream ifsa("./setup/SaveFileName.txt");
	ifsa>>dirname;//アドレス先/home/hiroshi/exp/exp40/data
	ifsa.close();

	ifstream ifsb("./setup/WorkDIR.txt");
	ifsb>>name;//アドレス先/home/hiroshi/exp/exp40/
	ifsb.close();

	sprintf(name,"%srunnum.txt",name);
	ifstream ifsc(name);
	ifsc>>name;
	RunNo=atoi(name);
	ifsc.close();

	//上書き確認
	sprintf(name,"%srun%05d.esd",dirname.c_str(),RunNo);
	cout << "生データ転送先: "<<name<<"\n" << flush;
	struct stat st1;
	int ret1 = stat(name,&st1);
	if(0 != ret1){}
	else{
		cout<<"message::"<<"データを上書きしますか？ Yes[1]/No[0]>>";
		cin >>a;

		if(a=="0"){
			cout<<"DAQモード終了\n";
			return 0;
		//if(a==0)exit(1);
		}}

  int MaxCycleNum = 0, m=0;
	ifstream ifs_d("./setup/EventNum.txt");
	ifs_d>>name;
	MaxCycleNum=atoi(name);
 cout << "最大イベント数：" <<MaxCycleNum<<endl<<flush;

  a="q";
	int i_loop=0;
  for(i_loop=0;i_loop<2;i_loop++){
  if(a!="0"&&a!="1"){
    cout<<"message::"<<"DAQ start Yes[1]/No[0]]>>";
    cin>>a;
    if(a=="1")break;
    else if(a=="0"||i_loop==1){
			cout<<"DAQモード終了\n";
			return 0;
  }}}

	sprintf(name,"%srun%05d.esd",dirname.c_str(),RunNo);
	ofstream file(name,ios::binary);

  unsigned int signal = 0;
  int EventNum = 0;

  signal += 32 << 24;
  signal += 100 << 16;
  send(socket, (char*)&signal, sizeof(int), 0);

 while(EventNum < MaxCycleNum){
  ADCOneCycle_wHeader_ver5(socket, file);
  EventNum++;
  if(0 == EventNum%1){
   cout <<"."<< flush;
   m++;
   if(0 == m%10)cout <<"\n"<< flush;
  }
  if(false||EventNum  == MaxCycleNum||ForceStop == 1){
   ADCStop(socket);
   EndADC = 1;
   int abort = 0;
   while(0 == ADCOneCycle_wHeader_ver5(socket, file)){
    usleep(1000);
    if(abort == 50){
	   ADCStop(socket);
	   abort = 0;
	   }
   cout << "."<<flush;
   ++abort;
      }
      EndADC    = 0;
      ForceStop = 0;
      break;
    }
  }
  cout << "End ADC" << endl;
  file.close();
  return 0;
}



//**********************
//  データ収集v5
int ADCOneCycle_wHeader_ver5(int socket, std::ofstream& file){
	//determined
  static const int NofHeader = 3;

  unsigned int DataBuffer_ve3[1000];
  memset(DataBuffer_ve3, 0, sizeof(DataBuffer_ve3));
  unsigned int *ptr_DataBuf = DataBuffer_ve3;
  unsigned int TotalRecvByte  = 0;
  unsigned int TotalRecvEvent = 0;
  static unsigned int sizeHeader = NofHeader*sizeof(int);

  unsigned int Header[NofHeader] = {1, 1, 1};
  int ret = 0;
  ret = receive(socket, (char*)Header, &sizeHeader);
  if(ret <= 0 && EndADC == 1){
    return -1;
  }
//************
//ヘッダー
//************
  if(Header[0] != 0xFFFFEA0C){
    std::cerr << "Fatal ADC ERROR : HEADER" << std::endl;
    std::cerr << "Header1 : " << std::hex << Header[0] 
	      << " Header2 : " << std::hex << Header[1]
	      << " Header3 : " << std::hex << Header[2] << std::endl;
    exit(-1);
  }
	else{
    unsigned int sizeData = (sizeof(int)*Header[1] & 0xffff);
				//total MPCs data size
    unsigned int NofWord = (Header[1] & 0xffff);
    unsigned int OneData[NofWord];
    receive(socket, (char*)OneData, &sizeData);

    memcpy(ptr_DataBuf, Header, sizeHeader);
    ptr_DataBuf += NofHeader;

    memcpy(ptr_DataBuf, OneData, sizeData);
    ptr_DataBuf += sizeData/sizeof(int);
    TotalRecvByte += sizeHeader + sizeData;//HEADER+MPPC用のメモリ
  }

  if(EndADC != 1){
    for(unsigned int i = 0; i<TotalRecvByte/sizeof(int); i++){
      unsigned int buffer = DataBuffer_ve3[i];
      file.write((char*)&buffer, sizeof(int));
   }}
  return 0;
}

void ADCStop(int socket){
  unsigned int signal = 0;
  std::cout << "ADC exit process" << std::endl;
  signal += 16 << 24;
  signal += 100 << 16;
  send(socket, (char*)&signal, sizeof(int), 0);
  sleep(1);
  signal = 0;
  signal += 100 << 16;
  send(socket, (char*)&signal, sizeof(int), 0);
  usleep(10000);
  return;
}

void ForceStop_FromCtrl_C(int signal){
  std::cout << "Stop request from user" << std::endl;
  ForceStop = 1;
  EndADC = 1;
}

int receive(int sock, char* data_buf, unsigned int *ReadLength){
  unsigned int revd_size     = 0;
  int tmp_returnVal = 0;

  while(revd_size < *ReadLength){
    tmp_returnVal = recv(sock, data_buf +revd_size, *ReadLength -revd_size, 0);
    if(tmp_returnVal < 0){
      int errbuf = errno;
      perror("TCP receive");
      if(errbuf == EAGAIN){
	if(EndADC == 1){
	  std::cout << "No data" << std::endl << std::flush;
	  break;
	}
	continue;
      }else if(errbuf == EINTR){
	continue;
      }else{
	exit(-1);
      }
    }
    revd_size += tmp_returnVal;
  }

    //    std::cout << "ret is " << std::dec << revd_size << std::endl;
  return revd_size;
}

int WriteData(int sock, unsigned int data){
  data += 128 << 24;
  send(sock, (char*)&data, sizeof(int), 0);
  unsigned int buf = 0;
  unsigned int length = 4;
  receive(sock, (char*)&buf, &length);
  if(data - buf){
    std::cerr << "### Data Transmit Error ###" << std::endl;
    std::cerr << "Transmited data is " << std::hex << data << std::endl;
    std::cout << "Returned data is   " << std::hex << buf << std::endl;
    return -1;
  }

  return 0;
}

int ReadData(int sock, unsigned int signal, unsigned int *data){
  signal += 64 << 24;
  send(sock, (char*)&signal, sizeof(int), 0);
  unsigned int length = 4;
  receive(sock, (char*)data, &length);
  return 0;
}

