/************************************:
オシロスコープ波形取得 by GPIB
コンパイル方法
$gc_gpib daq_osc1.c
$./daq_osc1

イベント数変更 
$cd /usr/local/GPIB/Tektronix/
$emacs -nw TektronixScope.h

***************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
static FILE *sp;
/************** Header Files ********/
//#include "fbimtn.h"                    // Motion Cntl Board
#include "/usr/local/GPIB/CommandLib/CommandLib.h"     // Command Interp\reter
#include "/usr/local/GPIB/Tektronix/TektronixScope.h"  //OscilloScope
#include "pcigpib.h"
#include "/usr/local/GPIB/GPG4301.h" //GPIB Interface Board GPG4301
char *pErr;
/************** Functions and Library *************/
#include "/usr/local/GPIB/CommandLib/CommandLib.c"               // Command Interp\reter
#include "/usr/local/GPIB/Tektronix/TektronixScope.c"
#include "/usr/local/GPIB/Tektronix/WaveFormStringToData.c"
#include "/usr/local/GPIB/GPG4301.c" //GPIB Interface Board GPG4301

int main(int argc, char *argv[]){
	float volt=20;//Oscillo range Scale[mV]
	float timeDiv=50;//Oscillo range[ns]
	float offsetDivs = 0;//-592
	char *filename="./outputdata/";//File name
	int filenum;
	int times=20;
	FILE *fp;
	FILE *gp;
	int i,j,m,TIMES=0;
	int nRet;
	char name[1000];
	static FILE *TV;
	double T_,V_;


//*****************************************************
// データ読み出し設定

	printf("=========\n   Setup\n=========\n");
	printf("CH1 Voltage Scale[mV](default 500mV)\n[int]>>");
	scanf("%f",&volt);
	printf("offset position[divs](default 0 divs)\n[int]>>");
	scanf("%f",&offsetDivs);
	printf("time Scale[ns](default 50ns)\n[int]>>");
	scanf("%f",&timeDiv);
	printf("イベント数は？\n[int]>>");
	scanf("%d",&times);
	printf("データ番号をいれてください\n[int]>>");
	scanf("%d",&filenum);


//*****************************************************
// オシロの初期化

	fprintf(stderr,"Initializing the GPIB...");
	InitializeBoard();
	InitializeGPIB( );
	ResetClearTGenerator(); 
	InitializeScope();
	fprintf(stderr,"[OK]\n");



//*****************************************************
// オシロ画面の制御
		//電圧スケール
		sprintf(commandString,"CH1:SCAle %10.8e",volt*1.0e-3);
		ExecuteCommand(commandString,ScopeDeviceAddrTable);

		//オフセットライン
		sprintf(commandString,"CH1:POSition %0.1f",offsetDivs);
		ExecuteCommand(commandString,ScopeDeviceAddrTable);

		//時間スケール
		sprintf(commandString,"HORizontal:MAIn:SCAle %10.8e",timeDiv*1.0e-9);
		ExecuteCommand(commandString,ScopeDeviceAddrTable);


//*****************************************************
// トリガー情報の設定

	ExecuteCommand("TRIGger:Main:EDGE",ScopeDeviceAddrTable);//トリガー設定
	ExecuteCommand("TRIGger:Main:EDGE:COUPling DC",ScopeDeviceAddrTable);//DCカップル
	//ExecuteCommand("TRIGger:Main:EDGE:SOUrce CH2",ScopeDeviceAddrTable);//トリガーチャンネル番号
	ExecuteCommand("TRIGger:Main:EDGE:SOUrce EXT",ScopeDeviceAddrTable);//トリガーチャンネル
	ExecuteCommand("TRIGger:Main:LEVel -0.5",ScopeDeviceAddrTable);//しきい値

	//ExecuteCommand("TRIGger:Main:EDGE:SLOPe RISe",ScopeDeviceAddrTable);//たちあがり
	ExecuteCommand("TRIGger:Main:EDGE:SLOPe FALL",ScopeDeviceAddrTable);//たちさがり

	//ここら辺はよくわからないや
	ExecuteCommand("TRIGger:Main:MODe NORMal", ScopeDeviceAddrTable);
	ExecuteCommand("*OPC", ScopeDeviceAddrTable);
	ExecuteCommand("While serial poll = 0, keep looping", ScopeDeviceAddrTable);

	//データ読み出しチャンネルの設定
	ExecuteCommand("DATa:SOUrce CH1", ScopeDeviceAddrTable);
	ExecuteCommand("DATa:ENCdg ASCIi", ScopeDeviceAddrTable);
	//ExecuteCommand("WFMOutper:BYT_Nr", ScopeDeviceAddrTable);

	//スタート時刻
	int a=1;
	sprintf(name,"DATa:STARt %d",a);
	ExecuteCommand(name, ScopeDeviceAddrTable);

	//ストップ時刻
	int b=2500;
	sprintf(name,"DATa:STOP %d",b);
	ExecuteCommand(name, ScopeDeviceAddrTable);


	//ファイル出力
	sprintf(name,"%sdata%03d.dat",filename,filenum);
	if((TV=fopen(name,"w"))==NULL){
		printf("We cannot open %s\n",name);
		exit(-1);}

//*****************************************************
//データ取得

		//イベントループ
		for(j=0;j<times;j++){
			fprintf(stderr,".");
			if(j%10==0)fprintf(stderr,"/");
			ExecuteCommand("CURVe?", ScopeDeviceAddrTable);
			ReceiveData(curveString, sizeof curveString, ScopeDeviceAddrTable);
			m = WaveFormStringToData(curveString, waveFormData);
			//データ収集ループ
			for(i=0;i<=b-a-1;i++){//DATa:STOP - DATa:STARt 
				T_ =(double)(i-(double)(b-a)/2)*timeDiv/5/50;//[ns]@200ns~400ps
				V_ =(double)waveFormData[i]*(double)volt/25.0;//[mV]
			//ファイル書き込み
			fprintf(TV,"%0.1f %0.1f\n",T_,V_);}
		fflush(TV);}

//*****************************************************
//クロージング
	fprintf(stderr,"\n");
	fclose(TV);//ファイル閉じる
	CheckTError();//
	//ResetClearTGenerator(); // Reset and Clear the OsciloScope
	// Finishing the GPIB communication
	PciGpibExFinishBoard(BoardAddress);
	Terminate("\n",PciGpibExInitBoard(BoardAddress,0));
}

