/************************************:
オシロスコープ波形取得 by GPIB
コンパイル方法
$gc_gpib get_oscillo15
$./get_oscillo15

イベント数変更 
$cd /usr/local/GPIB/Tektronix/
$emacs -nw TektronixScope.h

***************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
static FILE *sp;

/************** Header Files ********/
//#include "fbimtn.h"                    // Motion Cntl Board
#include "/usr/local/GPIB/CommandLib/CommandLib.h"     // Command Interp\reter
#include "/usr/local/GPIB/Tektronix/TektronixScope.h"  //OscilloScope
#include "pcigpib.h"
#include "/usr/local/GPIB/GPG4301.h" //GPIB Interface Board GPG4301
char *pErr;
/************** Functions and Library *************/
#include "/usr/local/GPIB/CommandLib/CommandLib.c"               // Command Interp\reter
#include "/usr/local/GPIB/Tektronix/TektronixScope.c"
#include "/usr/local/GPIB/Tektronix/WaveFormStringToData.c"
#include "/usr/local/GPIB/GPG4301.c" //GPIB Interface Board GPG4301

int main(int argc, char *argv[]){
	int Fin=1;
	float volt=20;//Oscillo range Scale[mV]
	float timeDiv=50;//Oscillo range[ns]
	float offsetDivs = 0;//-592
	char *filename="./Rawdata2/";//File name
	int filenum;

	printf("=========\n   Setup\n=========\n");
	printf("CH1 Voltage Scale[mV](default 500mV)\n[int]>>");
	scanf("%f",&volt);
	printf("offset position[divs](default 0 divs)\n[int]>>");
	scanf("%f",&offsetDivs);
//debug	printf("%01f",offsetDivs);
	printf("time Scale[ns](default 50ns)\n[int]>>");
	scanf("%f",&timeDiv);
	printf("データ番号をいれてください\n[int]>>");
	scanf("%d",&filenum);



	FILE *fp;
	FILE *gp;
	int i,j,m,TIMES=0;
	int nRet;

	char numberString[10];
	char waveFormString[500000];
	static FILE *TV;
	char TVname[128];
	double T_,V_;

	// Initialize the GPIB Board Number
	fprintf(stderr,"Initializing the GPIB boad..\n");
	InitializeBoard();
	fprintf(stderr,"done\n");

	// Initialize the GPIB Interface
	fprintf(stderr,"Initializing the GPIB interface..");
	InitializeGPIB( );
	fprintf(stderr,"done\n");

	// Reset and Clear the OsciloScope
	fprintf(stderr,"Initializing the oscilloscope..");
	ResetClearTGenerator(); 
	fprintf(stderr,"done\n");

	// Initialize the OsciloScope
	fprintf(stderr,"Initializing the oscilloscope..");
	InitializeScope();
	fprintf(stderr,"done\n");

//	for(TIMES=0; TIMES < Fin; TIMES++){
		/* Setup the voltage */
		fprintf(stderr,"Setting the scale..");
//		sprintf(commandString,"CH1:SCAle %10.8e",volt*1.0e-3);
		sprintf(commandString,"CH1:SCAle %10.8e",volt*1.0e-3);
		ExecuteCommand(commandString,ScopeDeviceAddrTable);
		//sprintf(commandString,"CH2:SCAle %10.8e",volt*1.0e-3);
		//ExecuteCommand(commandString,ScopeDeviceAddrTable);
		//ExecuteCommand("CH2:SCAle 200*1.0e-3",ScopeDeviceAddrTable);

//CH1position setting
		sprintf(commandString,"CH1:POSition %0.1f",offsetDivs);
//debug		fprintf(stderr,"message:%s",commandString);
		ExecuteCommand(commandString,ScopeDeviceAddrTable);

		//Setup the time per division 
		sprintf(commandString,"HORizontal:MAIn:SCAle %10.8e",timeDiv*1.0e-9);
		ExecuteCommand(commandString,ScopeDeviceAddrTable);
		fprintf(stderr,"done\n");

		//Decide Trigger Source and Level
		ExecuteCommand("TRIGger:Main:EDGE",ScopeDeviceAddrTable);
		ExecuteCommand("TRIGger:Main:EDGE:COUPling DC",ScopeDeviceAddrTable);//DCカップル
		ExecuteCommand("TRIGger:Main:EDGE:SOUrce CH2",ScopeDeviceAddrTable);//トリガーチャンネル番号
		ExecuteCommand("TRIGger:Main:LEVel -0.5",ScopeDeviceAddrTable);//しきい値

//たちあがり
//		ExecuteCommand("TRIGger:Main:EDGE:SLOPe RISe",ScopeDeviceAddrTable);

//たちさがり
//		ExecuteCommand("TRIGger:A:EDGE:SLOPe FALL",ScopeDeviceAddrTable);
		ExecuteCommand("TRIGger:Main:EDGE:SLOPe FALL",ScopeDeviceAddrTable);


		ExecuteCommand("TRIGger:Main:MODe NORMal", ScopeDeviceAddrTable);
		ExecuteCommand("*OPC", ScopeDeviceAddrTable);
		ExecuteCommand("While serial poll = 0, keep looping", ScopeDeviceAddrTable);

		//Decide Data Source
		ExecuteCommand("DATa:SOUrce CH1", ScopeDeviceAddrTable);
		ExecuteCommand("DATa:ENCdg ASCIi", ScopeDeviceAddrTable);
		//ExecuteCommand("WFMOutper:BYT_Nr", ScopeDeviceAddrTable);
	int a=1;
	char name[100];
	sprintf(name,"DATa:STARt %d",a);
		ExecuteCommand(name, ScopeDeviceAddrTable);
//		ExecuteCommand("DATa:STARt 4750", ScopeDeviceAddrTable);
int b=2500;
	sprintf(name,"DATa:STOP %d",b);
		ExecuteCommand(name, ScopeDeviceAddrTable);
//		ExecuteCommand("DATa:STOP 6000", ScopeDeviceAddrTable);

		//ExecuteCommand("DATa:STOP 10000", ScopeDeviceAddrTable);
		//ExecuteCommand("DATa:STOP 6250", ScopeDeviceAddrTable);
		//ExecuteCommand("WFMOutper?", ScopeDeviceAddrTable);
		//XYPlot(filename,timeDiv,volt);

//		sprintf(TVname,"%s_%d_WaveForm.data",filename,TIMES);
		sprintf(TVname,"%sdata%03d.dat",filename,filenum);
		if((TV=fopen(TVname,"w"))==NULL){
			printf("We cannot open %s\n",TVname);
			exit(-1);  
		}
		for(j=0;j<Times;j++){
			fprintf(stderr,"Number of times is %d\n",j+1);
			ExecuteCommand("CURVe?", ScopeDeviceAddrTable);
			ReceiveData(curveString, sizeof curveString, ScopeDeviceAddrTable);
			m = WaveFormStringToData(curveString, waveFormData);
			//fprintf(stdout, "%d data points\n", m);
			for(i=0;i<=b-a;i++){//DATa:STOP - DATa:STARt 
				//if(timeDiv <= 200)
//					T_ =((double)i+4750.0)/5.0;//[ns]@200ns~400ps
					T_ =(double)(i-(double)(b-a)/2)*timeDiv/5/50;//[ns]@200ns~400ps
				//if(timeDiv == 1000)
					//T_ =((double)i+4750.0)/1000.0;//[us]@1us
				//if(timeDiv == 2000)
					//T_ =((double)i+4750.0)/500.0;//[us]@2us
				V_ =(double)waveFormData[i]*(double)volt/25.0;//[mV]
				fprintf(TV,"%0.3f %0.01f\n",T_,V_);
			}
			fflush(TV);
		}
		fclose(TV);
		CheckTError();
//	}
	ResetClearTGenerator(); // Reset and Clear the OsciloScope
	// Finishing the GPIB communication
	PciGpibExFinishBoard(BoardAddress);
	Terminate("\n",PciGpibExInitBoard(BoardAddress,0));
}

