#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "event.h"
#include "/usr/local/camlib/camlib.c"
#include "/usr/local/camlib/camlib.h"

//構造体
struct device_prop{
	int fd;
	struct event_header *event;//event.hの構造体にリンク
	unsigned int *data;
	int max_data;};

//初期化
int fe_init(struct device_prop *dev){
	return 0;}

//**********************************************************************
//	ADC & TDC channel sonfiguration
//
#define NADC 4//ADC 読み出し出力数
static int MOD_NUM=5;//モジュール番号
static int SUB_NUM[NADC]={0,1,2,3},dat,q,x;

//#define NTDC 8//TDC 読み出し出力数
//static int MOD_NUM2=2;//モジュール番号
//static int SUB_NUM2[NTDC]={0,1,2,3,4,5,6,7};
//**********************************************************************

//CAMAC read
int camac_read(struct device_prop *dev){
	int ndata=0;
	int i;
	for(i=0;i<NADC;i++){
		CAMAC(NAF(MOD_NUM,SUB_NUM[i],0),&dat,&q,&x);
		dev->data[i]=dat;
		ndata++;}
//	for(i=0;i<NTDC;i++){
//		CAMAC(NAF(MOD_NUM2,SUB_NUM2[i],0),&dat,&q,&x);
//		dev->data[i+NADC]=dat;
//		ndata++;}
		return ndata;}

//Finish function
int fe_final(){
	return 0;}



//main
int main(int argc, char* argv[]){
	struct device_prop dp;
	struct event_header *event;
	static unsigned int databuf[1024];

	int event_number;
	int nread, nwrite;
	int i;

	COPEN();//CAMAC Open
	CGENZ();//CAMAC data clear

	event = (struct event_header *)databuf;
	dp.data = (unsigned int *)((char *)databuf + sizeof(struct event_header));
	dp.event = event;

	event->magic = EV_MAGIC;
	event->size = 0;
	event->event_number = 0;
	event->run_number = 0;
	event->node_id = 0;
	event->type = 0;
	event->nblock = 0;
	event->reserve = 0;

	fe_init(&dp);

	event_number = 0;
	while(1){
		CAMAC(NAF(MOD_NUM,SUB_NUM[0],8),&dat,&q,&x);
		event->event_number = event_number;
		if(q==1){
			nread = camac_read(&dp);
			dp.data[nread++] = EV_TRAILER;
			event->size = sizeof(struct event_header)/sizeof(unsigned int) + nread;
			nwrite = fwrite(databuf, sizeof(unsigned int), event->size, stdout);
			fflush(stdout);}
		event_number++;
		for(i=0;i<NADC;i++)
			CAMAC(NAF(MOD_NUM,SUB_NUM[i],9),&dat,&q,&x);}
	fe_final(&dp);
	
	CCLOSE();//CAMAC Close
	return 0;}
