/*fedummy.c
ダミーイベント作成プログラム*/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "event.h"

//構造体
struct device_prop{
	int fd;
	struct event_header *event;//event.hの構造体にリンク
	unsigned int *data;
	int max_data;
	};

//ガウスのランダム数値を生成関数定義
double grand(){
	int try=100;
	long long int sum=0;
	double gaus=0;
	int i;
	for(i=0;i<try;i++){
		sum += rand();
		}
	gaus=(double)sum/RAND_MAX/try;
	return gaus;
	}


//初期化
int fe_init(struct device_prop *dev){
	return 0;
	}


//待つ
int fe_wait(struct device_prop *dev){
	usleep(100*1000);
/*マイクロセカンド単位の sleep関数
#include <unistd.h>のなかに入っている関数*/
	return 0;
	}



int fe_read(struct device_prop *dev){
	int ndata=0;
	int i;
	for(i=0;i<4;i++){
		dev->data[i] = grand() * 1000;
		ndata++;
		}
	return ndata;
	}


int fe_final(){
	return 0;
	}




int main(int argc, char* argv[])
{
	struct device_prop dp;
	struct event_header *event;
	static unsigned int databuf[1024];

	int event_number;
	int nread, nwrite;

	event = (struct event_header *)databuf;
	dp.data = (unsigned int *)((char *)databuf + sizeof(struct event_header));
	dp.event = event;

	event->magic = EV_MAGIC;
	event->size = 0;
	event->event_number = 0;
	event->run_number = 0;
	event->node_id = 0;
	event->type = 0;
	event->nblock = 0;
	event->reserve = 0;

	fe_init(&dp);

	event_number = 0;
	while(1){
		int i;
		event->event_number = event_number;
		if(fe_wait(&dp)==0){
			nread = fe_read(&dp);
			dp.data[nread++] = EV_TRAILER;
			event->size = sizeof(struct event_header)/sizeof(unsigned int) + nread;
			#if 0
			for (i = 0 ; i < event->size ; i++) {
				printf("%08x ", databuf[i]);
			}
			printf("\n");
#else
			nwrite = fwrite(databuf, sizeof(unsigned int), event->size, stdout);
			fflush(stdout);
					//	for (i = 0 ; i < event->size ; i++) {
		//	}
#endif
		}
		event_number++;
	}

	fe_final(&dp);

	return 0;
}
