#include <iostream>
#include <iomanip>
#include <vector>
#include <sstream>
#include <netinet/in.h>
#include <stdio.h>
#include <cstring>
#include <cstdlib>
#include "TApplication.h"
#include "TCanvas.h"
#include "TH1F.h"
#include "TThread.h"
#include "event.h"
#include <fstream>

using namespace std;

int decode_data(char *buf, vector<int> &data){
	struct event_header *eheader = reinterpret_cast<struct event_header *>(buf);
	unsigned int *datablock = reinterpret_cast<unsigned int *>(buf + sizeof(struct event_header));
	//unsigned int magic = ntohl(eheader->magic);
	unsigned int magic = eheader->magic;
	int ndata;
	data.clear();
	data.resize(2);
	if(magic==EV_MAGIC){
		data[0] = static_cast<int>(datablock[0]);
		data[1] = static_cast<int>(datablock[1]);
		data[2] = static_cast<int>(datablock[2]);
		data[3] = static_cast<int>(datablock[3]);
		ndata = 2;
		}
	else{
		for(int i=0;i<4;i++)
		data[0] = -1;
		data[1] = -1;
		data[2] = -1;
		data[3] = -1;
		ndata = 0;
		cout << "MAGIC ERROR : " << hex << magic<< dec << endl;
		}
	return ndata;
	}

#define NADC 4
static TH1F *hadc[NADC];

struct device_prop{
	struct event_header *event;//event.hの構造体にリンク
	//char ofsname;
	};


//ofstream ofs("data/tmp.dat");//出力ファイル

int hist_init(){
	char name[100];
	for (int i=0;i<NADC;i++){
		sprintf(name,"TDC[%d]",i);
		hadc[i] = new TH1F(name,name,512,0,4096);
		}
	return 0;
	}

int hist_fill(vector<int> &vtdc){
	for (int i = 0 ; i < NADC ; i++) {
		hadc[i]->Fill(vtdc[i], 1.0);
		cout<<(int)vtdc[i]<<" ";
	}
	cout<<endl;
	return 0;
}

static int no_exit = 0;

void reader(void *arg = NULL){
	static char cbuf[1024];
	struct event_header *eheader = reinterpret_cast<struct event_header *>(cbuf);
	unsigned int*datablock = reinterpret_cast<unsigned int *>(cbuf + sizeof(struct event_header));
	vector<int>data;
	int event_number = 0;
	while(true){
		cin.read(cbuf,sizeof(struct event_header));
		if(cin.eof())break;
		int rsize = (eheader->size - (sizeof(struct event_header)/sizeof(unsigned int)))*sizeof(unsigned int);
		cin.read(reinterpret_cast<char *>(datablock), rsize);
		if(cin.eof())break;


		if (decode_data(cbuf, data) > 0) {
			hist_fill(data);
			//cout << "# " << event_number << ": " << data[0] << " " << data[1] << endl;
		} else {
			cerr << "Invalid Header "
				//<< ntohl(static_cast<unsigned int>(cbuf[0])) << endl;
				<< static_cast<unsigned int>(cbuf[0]) << endl;
			break;
		}
		//if ((event_number % 100) == 0) cout << "Event : " << event_number << endl;
		event_number++;
	}

	if (! no_exit) exit(0);
}


int ta_argc = 1;
char *ta_argv[] = {"App"};
static TApplication *app = new TApplication("App", &ta_argc, ta_argv);
static TCanvas *c1 = new TCanvas("c1", "Online Display",250,200,700,550);

void updater(void *arg = NULL){
	while (true) {
		TThread::Sleep(0.00001, 0);
		c1->cd(1)->Modified();
		c1->cd(2)->Modified();
		c1->cd(3)->Modified();
		c1->cd(4)->Modified();
		c1->Update();
	}
}


int main(int argc, char* argv[]){
	for(int i=1;i<argc;i++){
		if(strncmp(argv[i], "--no-exit", 9) == 0) no_exit = 1;
		}
	hist_init();

	c1->Divide(2, 2);
	c1->cd(1);	hadc[0]->Draw();
	c1->cd(2);	hadc[1]->Draw();
	c1->cd(3);	hadc[2]->Draw();
	c1->cd(4);	hadc[3]->Draw();
	c1->Update();
	c1->Flush();

	TThread threader("Reader", &reader, NULL);
	TThread thupdater("Updater", &updater, NULL);
	threader.Run();
	thupdater.Run();

	app->Run();
	return 0;
	}



