#!/usr/bin/env python

import os
import popen2
import threading
from socket import *
from Tkinter import *

import time
from struct import *


def tcpsend(host, port, line):
  addr = (gethostbyname(host), port)
  sock = socket(AF_INET, SOCK_STREAM)
  try:
    sock.connect(addr)
  except error, msg:
    app.textbox.insert(END, 'connect faild: ' + host + port)
    print 'connect faild: ', host, port
    return

  sock.send(line)
  data = sock.recv(2048)
  app.textbox.insert(END, data)
  sock.close()

def get_runno_from_file(filename):
  fd = file(filename, "r")
  runno = int(fd.readline())
  fd.close()
  runno = runno + 1
  fd = file(filename, "w")
  fd.write(str(runno))
  fd.close()
  return runno

def write_comment_file(filename):
  runno = app.runno.get()
  comment = app.comment.get()
  cf = file(filename, "a+")
  cf.write('RUN ' + runno + ' ' +time.ctime() + ': ' + comment + '\n')
  cf.close()
  return


class DAQreader(threading.Thread):
  def __init__(self, runno):
    threading.Thread.__init__(self)
    self.setDaemon(True)
    self.running = 0
    self.runno = runno

  def run(self):
    if not self.running:
      self.running = 1
      self.datafile = './data/run' + '0'*(6 - len(str(self.runno))) + str(self.runno) + '.dat'

      #print 'is_rec', app.is_rec.get()
      if app.is_rec.get() == 1 :
        self.child = popen2.Popen4('./run.sh ' + self.datafile)
        app.textbox.see(END)
        app.textbox.insert(END, "## DAQ start ##")
      else :
        self.child = popen2.Popen4('./run_norec.sh ' + self.datafile)
        app.textbox.see(END)
        app.textbox.insert(END, "## DAQ start without recording ##")

      while self.running:
        line = self.child.fromchild.readline()
        if line == '' :
          if self.child.poll() != -1:
            app.textbox.see(END)
            app.textbox.insert(END, '## DAQ stop !! ##\n')
            self.child.fromchild.close()
            self.child.tochild.close()
            self.running = 0
            self.stop()
            app.daq = None
        else :
          #app.textbox.see(END)
          #app.textbox.insert(END, line)
          app.label.configure(text=line.rstrip('\n'))

  def stop(self):
    if self.running:
      self.join()

  def killchild(self):
    if self.running:
      #os.kill(self.child.pid, 9)
      #os.system('killall -9 socket')
      #os.system('killall -9 nc')
#      os.system('killall -9 fedummy')
      os.system('killall -9 camac')
      #print 'killall zcat'


class App(Frame):
  def init(self):
    self.label = Label(self, text=' - DAQ - ', fg='blue')
    self.bstart = Button(self, text='Start', command=self.run_start)
    self.bstop = Button(self, text='Stop', command=self.run_stop)
    #self.btrigon = Button(self, text="Trig. ON", command=self.trig_on)
    #self.btrigoff = Button(self, text="Trig. OFF", command=self.trig_off)
    self.bquit = Button(self, text='Quit', command=self.quit_clicked)
    self.is_rec = IntVar()
    self.is_rec.set(0)
    #self.cbrec = Checkbutton(self, text='Record    ', onvalue=1, offvalue=0, variable=self.is_rec, command=self.cb)
    self.cbrec = Checkbutton(self, text='Record    ', onvalue=1, offvalue=0, variable=self.is_rec)
    self.textbox = Text(self, width=60, height=4)
    self.lrunno = Label(self, text='Run No.')
    self.runno = Entry(self)
    #self.runno.insert(END,'1')
    self.lmaxevent = Label(self, text='Max. Event')
    self.maxevent = Entry(self)
    self.maxevent.insert(END,'100')
    self.comment = Entry(self, width=60)
    self.lasttime = Label(self)

    self.label.pack(side=TOP)
    self.textbox.pack(side=TOP)
    self.comment.pack(side=TOP)
    self.lasttime.pack(side=TOP)
    self.bstart.pack(side=LEFT)
    self.bstop.pack(side=LEFT)
    #self.btrigon.pack(side=LEFT)
    #self.btrigoff.pack(side=LEFT)
    self.cbrec.pack(side=LEFT)
    self.lrunno.pack(side=LEFT)
    self.runno.pack(side=LEFT)
#    self.lmaxevent.pack(side=LEFT)
#    self.maxevent.pack(side=LEFT)
    self.bquit.pack(side=RIGHT)

    #self.running = 0
    self.daq = None 

  def cb(self):
    print "is rec", self.is_rec.get()

  def quit_clicked(self):
    self.master.destroy()

  def run_start(self):
    runno = get_runno_from_file('./runno.txt')
    app.runno.delete(0, END)
    app.runno.insert(END, str(runno))

    if self.daq is None:
      self.daq = DAQreader(runno)
      self.daq.start()

    write_comment_file('./comment.txt')
    app.lasttime.configure(text='Last Run Start Time: ' + time.ctime())

  def run_stop(self):
    if self.daq is not None:
      self.daq.killchild()
      #self.eb.stop()
      self.daq = None


  def trig_on(self):
    f = self.freq.get()
    self.textbox.insert(END, 'START ' + f +'\n')
    tcpsend('onl2007', 9500, 'START ' + f + '\n')

  def trig_off(self):
    tcpsend('onl2007', 9500, 'STOP\n')
    self.textbox.insert(END, 'STOP\n')

  def __init__(self, master=None):
    Frame.__init__(self, master)
    self.pack()
    self.init()


if __name__ == "__main__":
  app = App()

#  host = 'localhost'
#  port = 8881
#  addr = (gethostbyname(host), port)
#  sock = socket(AF_INET, SOCK_STREAM)
#  try:
#    sock.connect(addr)
#  except error, msg:
#    app.textbox.insert(END, 'connect faild: ' + host + port)
#    print 'connect faild: ', host, port


  app.mainloop()

#  sock.close()
#  message.stop()
  print 'END OF MAIN'
